clear all;
close all;

maxiter = 100;
data0 = load('MichFF0.txt');
ff = data0(200:900,1)';
mich0 = data0(200:900,2)'+1i*data0(200:900,3)';
data1 = load('MichFF1.txt');
mich1 = data1(200:900,2)'+1i*data1(200:900,3)';
michrat = mich0./mich1;
%%
s=2*pi*i*ff;
Ns=length(s);
N=8; %order of approximation
%N=7; %order of approximation
poles=-2*pi*logspace(0,log10(ff(length(ff))),N); %Initial poles
weight=ones(1,Ns); %All frequency points are given equal weight

%for k=1:Ns         %For some reason vectfit3 prefers this extra dimension.
%  F(1,k)=DPD1(k);  %
%  F(1,k)=DPD2(k);  %
%end                %

%opts.relax=1;      %Use vector fitting with relaxed non-triviality constraint
opts.stable=1;     %Enforce stable poles
opts.asymp=1;      %Include both D, E in fitting
opts.skip_pole=0;  %Do NOT skip pole identification
opts.skip_res=0;   %Do NOT skip identification of residues (C,D,E)
opts.cmplx_ss=1;   %Create complex state space model

opts.spy1=0;       %No plotting for first stage of vector fitting
opts.spy2=0;       %Don't Create magnitude plot for fitting of f(s)
opts.logx=1;       %Use logarithmic abscissa axis
opts.logy=1;       %Use logarithmic ordinate axis
opts.errplot=0;    %Do not Include deviation in magnitude plot
opts.phaseplot=0;  %Do not produce plot of phase angle (in addttn to magnitiude)
opts.legend=1;     %Do include legends in plots


%%
disp('vector fitting...')
for miter=1:maxiter
   [SER,poles,rmserr,fit]=vectfit4(michrat,s,poles,weight,opts);
end
disp('Done with fit.')


A=full(SER.A);
B=full(SER.B);
C=full(SER.C);
D=full(SER.D);
E=full(SER.E);
fprintf('rmserr=%f\n',rmserr);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
save('michratvf.mat','A','B','C','D','E');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


[z, p, k] = ss2zp(A, B, C, D);
mysys = zpk(z, p, k);

%% Get the OMCAA fit for the frequency range of f and a very low frequency
%% point.
%f_wide=[(1:100)';f];
ss=2*pi*i*ff;
for jj=1:length(ff)
  OLGres(jj)=C*inv(ss(jj)*eye(size(A))-A)*B+D+ss(jj)*E;
end

%DCvalue=abs(OLGres(1));
%OLGres=-OLGres/DCvalue; %normalization
%DPD1=-DPD1/DCvalue;
%DPD2=-DPD2/DCvalue;
%F=-F/DCvalue;

%figure
%subplot(2,2,1)
%loglog(ff,abs(OLGmismatch), 'x', ff, abs(OLGres))
%legend('data', 'fit', 'Location', 'SouthWest');
%ylabel('abs')
%title 'OLG residual fit'
%grid on

%save H1_OLGresidual_939168495.mat A B C D E
